#see polkit-mozjs
#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		polname		polkitd
#-----------------------------------------------------------------------------
Name		:	polkit
Version		:	125
Release		:	17.0.10.rel%{?dist}

Summary		:	PolicyKit Authorization Framework

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	LGPLv2+
URL		:	https://github.com/polkit-org/polkit

Source0		:	%{name}-%{version}.tar.gz
#-----------------------------------------------------------------------------
BuildRequires   :       duktape-devel
BuildRequires   :       dbus-python
BuildRequires   :       dbus-daemon
BuildRequires   :       dbus-devel
BuildRequires   :       docbook-xsl
BuildRequires   :       docbook-xml
BuildRequires   :       elogind-devel
BuildRequires   :       eudev-devel
BuildRequires   :       expat-devel
BuildRequires   :       gcc-c++
BuildRequires   :       gettext
BuildRequires   :       glib-devel
BuildRequires   :       gtk-doc
BuildRequires   :       gobject-introspection
BuildRequires   :       intltool
BuildRequires   :       libtool
BuildRequires   :       libxslt
BuildRequires   :       linux-headers
BuildRequires   :       meson
BuildRequires   :       ninja
BuildRequires   :       pam-devel
BuildRequires   :       python-dbusmock
BuildRequires   :       python3-pygobject
BuildRequires   :       python3-setuptools

Requires	:	elogind
Requires	:	%{name}-libs = %{version}-%{release}
Requires	:	shadow
#-----------------------------------------------------------------------------
%description
polkit is a toolkit for defining and handling authorizations.
It is used for allowing unprivileged processes to speak to
privileged processes.

#-----------------------------------------------------------------------------
%files		-f %{name}-1.lang
%defattr(-,root,root,-)
%{_bindir}/pkaction
%{_bindir}/pkcheck
%{_bindir}/pk-example-frobnicate
%attr (6755,root,root) %{_bindir}/pkexec
%{_bindir}/pkttyagent
%{_libdir}/pam.d/%{name}-1
%attr(0700,%{polname},root) %dir %{_sysconfdir}/%{name}-1/rules.d
%dir %{_sysconfdir}/%{name}-1/
%{_libdir}/%{name}-1/%{name}d
%attr (6755,root,root) %{_libdir}/%{name}-1/%{name}-agent-helper-1
%{_datadir}/%{name}-1/rules.d/50-default.rules
%{_datadir}/%{name}-1/actions/org.freedesktop.policykit.policy
%{_datadir}/%{name}-1/actions/org.freedesktop.policykit.examples.pkexec.policy
%{_datadir}/%{name}-1/policyconfig-1.dtd
%{_datadir}/dbus-1/system-services/org.freedesktop.PolicyKit1.service
%{_datadir}/dbus-1/system.d/org.freedesktop.PolicyKit1.conf
%{_mandir}/man1/*.1.gz
%{_mandir}/man8/*.8.gz

#polkit 125
%{_libdir}/systemd/system/%{name}.service
%{_libdir}/sysusers.d/%{name}.conf
%{_libdir}/tmpfiles.d/%{name}-tmpfiles.conf
#-----------------------------------------------------------------------------
%pre
if [ "$1" = 1 ]; then
  if [ ! $(getent group %{polname}) ]; then
    /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{polname}
    /usr/sbin/useradd 				\
	-r					\
	-c "PolicyKit Daemon Owner"		\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{polname}				\
	-s /bin/false				\
	-d %{_sysconfdir}/%{name}-1		\
	%{polname}
    fi
  fi

#after upgrade or remove
%preun
if [ "$1" = 0 ]; then
  /usr/sbin/userdel %{polname}
  /usr/sbin/groupdel %{polname}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

#=============================================================================
%package		devel
Summary		:	Development files for polkit


Requires	:	%{name}-libs = %{version}-%{release}
Requires	:	%{name}-docs = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
Development files for polkit.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/%{name}-1/%{name}agent/*.h
%{_includedir}/%{name}-1/%{name}/*.h
%{_libdir}/lib%{name}-*so
%{_libdir}/pkgconfig/%{name}-agent-1.pc
%{_libdir}/pkgconfig/%{name}-gobject-1.pc
%{_datadir}/gettext/its/%{name}.its
%{_datadir}/gettext/its/%{name}.loc
%{_datadir}/gir-1.0/*.gir

#=============================================================================
%package		libs
Summary		:	Libraries for polkit


Requires	:	%{name} = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		libs
Libraries files for polkit.

#-----------------------------------------------------------------------------
%files			libs
%defattr(-,root,root,-)
%{_libdir}/lib*.so.*
%{_libdir}/girepository-1.0/*.typelib

#=============================================================================
%package		docs
Summary		:	Development documentation for polkit


Requires	:	%{name}-devel = %{version}-%{release}

BuildArch	:	noarch
#-----------------------------------------------------------------------------
%description		docs
Development documentation for polkit.

#-----------------------------------------------------------------------------
%files			docs
%defattr(-,root,root,-)
%{_datadir}/gtk-doc/html/%{name}-1/*.html
%{_datadir}/gtk-doc/html/%{name}-1/*.png
%{_datadir}/gtk-doc/html/%{name}-1/style.css

#=============================================================================
%prep
%setup -q -n %{name}-%{version}
sed -i							\
  -e '/systemd_sysusers_dir/s/^/#/'			\
  meson.build

#-----------------------------------------------------------------------------
#building application
%build

meson setup						\
        --prefix=%{_prefix}				\
	--includedir=%{_includedir}			\
	--sysconfdir=%{_sysconfdir}			\
	--libdir=%{_libdir}				\
	--libexecdir=%{_libexecdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--infodir=%{_infodir}				\
	--sharedstatedir=%{_var}/lib			\
	--buildtype=release				\
	-D polkitd_user=%{polname}			\
	-D os_type=lfs					\
	-D examples=true				\
	-D gtk_doc=true					\
	-D session_tracking=elogind			\
	-D man=true					\
	-D tests=true					\
	-D js_engine=duktape				\
	_bld

meson compile						\
	-C _bld						\

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
%check
#polkit-125 test is ONLY working with CLONE_NEWUSER
#system (test need to be run on a container started via
#"vzgot -U boot container_name")
#
#meson test						\
#	-C _bld						\
#	--print-errorlogs -t 3

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

meson install						\
		-C _bld					\
		--destdir=%{buildroot}			\

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

%find_lang %{name}-1

#-----------------------------------------------------------------------------
%changelog
